#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

struct Foglal {
	string vnev, knev;
	string ido;
	string timestamp;
};

int main()
{
	vector<Foglal> fogado;
	ifstream fin;
	fin.open("fogado.txt");
	Foglal akt;
	while(fin >> akt.vnev >> akt.knev >> akt.ido >> akt.timestamp)
		fogado.push_back(akt);
	fin.close();
	cout << "2. feladat" << endl;
	cout << "Foglalasok szama: " << fogado.size() << endl;

	cout << "3. feladat" << endl;
	cout<< "Adjon meg egy nevet: ";
	string vneve, kneve;
	cin >> vneve >> kneve;
	int db = 0;
	for(auto f : fogado)
		if(f.vnev == vneve && f.knev == kneve)
			db++;
	if(db != 0)
		cout << vneve << " " << kneve << " neven " << db << " idopontfoglalas van."<< endl;
	else
		cout << "A megadott neven nincs idopontfoglalas" << endl;

	cout << "4. feladat" << endl;
	cout << "Adjon meg egy ervenyes idopontot: ";
	string idopont;
	cin >> idopont;

	vector<string> nevsor;
	for(auto f : fogado)
		if(f.ido == idopont)
			nevsor.push_back(f.vnev+" " + f.knev);
	for(size_t i = 0; i < nevsor.size()-1; i++) {
		size_t minhely = i;
		for(size_t j = i + 1; j < nevsor.size(); j++)
			if(nevsor[j]<nevsor[minhely] )
				minhely = j;
		swap(nevsor[i], nevsor[minhely]);
	}

	ofstream fout;
	string fnev= idopont.substr(0, 2) + idopont.substr(3, 2) + ".txt";
	fout.open(fnev);
	for(auto n : nevsor) {
		cout << n << endl;
		fout << n << endl;
	}
	fout.close();

	cout << "5. feladat" << endl;
	int minhely = 0;
	for(size_t i = 1; i < fogado.size(); ++i)
		if(fogado[i].timestamp < fogado[minhely].timestamp)
			minhely = i;
	cout << "Tanar neve: " << fogado[minhely].vnev << " " << fogado[minhely].knev<< endl;
	cout << "Foglalt idopont: " << fogado[minhely].ido << endl;
	cout << "Foglalas ideje: " << fogado[minhely].timestamp << endl;

	cout << "6. feladat" << endl;

	string idok[12] = {"16:00", "16:10", "16:20", "16:30", "16:40", "16:50", "17:00", "17:10", "17:20", "17:30", "17:40", "17:50"};
	bool foglalt[12] = {false};
	for(auto f : fogado)
		if(f.vnev == "Barna" && f.knev == "Eszter") {
			size_t i;
			for(i = 0; f.ido != idok[i]; ++i)
				;
			foglalt[i] = true;
		}

    for (size_t i = 0; i < 12; ++i)
        if(!foglalt[i]) cout << idok[i] << endl;
    size_t haza;
    for (haza = 11; haza>=0 && !foglalt[haza]; --haza )
    ;
    cout << "Barna Eszter legkorabban tavozhat: " << idok[haza + 1] << endl;
	return 0;
}
